/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_APIStore		//<c><e>RDFAPI_Store<a>public<d>RDF storage class
(
_storeURL,		//<p>string<d>URL or null for in-memory model
_storage		//<p>int<d>Storage mode according to loading process
){
const ASSERTING = false;
//================
this.RDFAPI_APIStore = function		//<m>void<a>private<d>class constructor
(
storeURL,	//<p>string<d>URL or null for in-memory model
storage		//<p>int<d>Storage mode according to loading process
){
this.prototype		= RDFAPI_Store;
this.prototype(storeURL, storage);
this.className		= 'RDFAPI_APIStore';
//i12n
}//</m>RDFAPI_APIStore



//================
this.getSubjectStatementSet = function		//<m>Object<a>public<d>Get an enumeration of all statements of a subject
(
subject		//<p>Object<d>Subject nsIRDFResource
){
const
/*boolean*/OUTCOMING_ARC = true;
try{
	subject instanceof Components.interfaces.nsIRDFResource;
	var
	/*Object*/predicate, object, objectEnum,
	/*int*/at = 0;						//statementSet index
	/*Object[]*/statementSet = [],
	predicateEnum = this.getArcSet(subject, OUTCOMING_ARC);
	for( ; predicateEnum.hasMoreElements(); ){
		predicate = predicateEnum.getNext();
		predicate instanceof Components.interfaces.nsIRDFResource;
		objectEnum = this.store.GetTargets(subject, predicate, true);
		for( ; objectEnum.hasMoreElements(); ){
			object = objectEnum.getNext();
			if(!(object instanceof Components.interfaces.nsIRDFResource)) object instanceof Components.interfaces.nsIRDFLiteral;
			statementSet[at++] = new RDFAPI_Statement(predicate, subject, object);
			}
		}
	return statementSet;
	}
catch(e){
	return null;
	}
}//</m>getSubjectStatementSet



this.RDFAPI_APIStore(_storeURL, _storage);
}//</c>RDFAPI_APIStore

