/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_Iterator		//<c><a>protected<d>RDF collection iterator class
(
_accessor		//<p>RDFAPI_Store<d>Model accessor
){
//================
this.RDFAPI_Iterator = function		//<m>void<a>private<d>class constructor
(
accessor		//<p>RDFAPI_Store<d>Model accessor -- optional
){
this.className	= 'RDFAPI_Iterator';
this.accessor	= accessor;
}//</m>RDFAPI_Iterator



//================
this.getIterating = function		//<m>Object<a>public<d>Iterate thru the collection calling a callback method at each iteration
(
collection,		//<p>Object<d>Enumeration to iterate
referrer,		//<p>Callback method (arguments: an RDF object (node, resource, etc.), an iteration counter)
caster			//<p>Item conversion method
){
for(var i=0;collection.hasMoreElements();i++){
	var
	item = collection.getNext();
	referrer.getIteration((this.accessor && caster) ? this.accessor[caster](item) : item, i);
	}
}//</m>getIterating



this.RDFAPI_Iterator(_accessor);
}//</c>RDFAPI_Iterator

