/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ASSERT_Abstract_Failure		//<c><a>public<d>Failure abstract class
(){
//================
this.ASSERT_Abstract_Failure = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'ASSERT_Abstract_Failure';
this.setIn();
}//</m>ASSERT_Abstract_Failure



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
this.warning	= false;
this.caller		= null;
this.comment	= null;
this.expected	= null;
this.stat		= null;

}//</m>setIn


//================
this.setCaller = function		//<m>string<a>private<d>
(
id		//<p>string<d>function name and test comment
){
return this.testUndefinedArgument(id) ? '(not specified)' : id.substr(0, id.indexOf(':'));
}//</m>setCaller


//================
this.setComment = function		//<m>string<a>private<d>
(
id		//<p>string<d>function name and test comment
){
return this.testUndefinedArgument(id) ? '' : id.substr(id.indexOf(':') + 1);	///skip :
}//</m>setComment


//================
this.setStat = function		//<m>void<a>private<d>
(
stat	//<p>ASSERT_ReportStat<d>Stat instance
){
this.stat = stat;
}//</m>setStat


//================
this.getSource = function		//<m>string<a>protected<d>
(){
return sprintf('%s [line: %s]', this.filename, this.lineNumber);
}//</m>getSource


//================
this.getCaller = function		//<m>string<a>protected<d>
(){
return this.caller;
}//</m>getCaller


//================
this.getComment = function		//<m>string<a>protected<d>
(){
return this.comment;
}//</m>getComment


//================
this.getExpected = function		//<m>string<a>protected<d>
(){
return this.expected.getArgumentAsText();
///return this.found;
}//</m>getExpected


//================
this.getStat = function		//<m>ASSERT_ReportStat<a>protected<d>
(){
return this.stat;
}//</m>getStat


//================
this.isWarning = function		//<m>boolean<a>protected<d>
(){
return this.warning;
}//</m>isWarning



//================
this.testUndefinedArgument = function		//<m>boolean<a>private<d>
(
argument		//<p>any<d>Argument to test
){
return (new ASSERT_Argument(/*undefined*/)).isUndefined(argument);
}//</m>isWarning



this.ASSERT_Abstract_Failure();
}//</c>ASSERT_Abstract_Failure


